/*

					Oscilloscope AVR

			Copyrights 2008,  Yoshi Hiroshi

				ADC Block - ATmega644P
*/

#define COMMAND_STATUS_IDLE						0
#define COMMAND_STATUS_GET_OFFSET				1
#define COMMAND_STATUS_SET_RANGE				4
#define COMMAND_STATUS_SET_POSITION				5
#define COMMAND_STATUS_SET_TRIGGER_MODE			6
#define COMMAND_STATUS_SET_TRIGGER_LEVEL		7
#define COMMAND_STATUS_SET_SWITCH				8

#define TRIGGERMODE_SLOPE_PLUS					0
#define TRIGGERMODE_SLOPE_MINUS					1
#define SAMPLING_NOT_INITED						0
#define SAMPLING_INITED							1
#define POLARITY_POSITIVE						0
#define POLARITY_NEGATIVE						1
#define ADC_DATA_UNSIGNED						0
#define ADC_DATA_SIGNED							1

extern volatile unsigned char triggerMode;
extern volatile unsigned char triggerLevel;
extern volatile unsigned char samplingInited;  // 0:NotInited, 1:Inited
extern volatile unsigned char polarity_switch; // 0:Plus, 1:Minus
extern volatile unsigned char signed_switch;   // 0:NoSigned, 1:Signed

void CommandInit();
void ControlPortOut();
void DoCommand(unsigned char c);

void GetDeviceType();
void ClearAll();
void SetChannelRange(unsigned char val);
void SetChannelPosition(unsigned char val);
void SetChannelTriggerMode(unsigned char val);
void SetChannelTriggerLevel(unsigned char val);
void SetChannelSwitch(unsigned char val);
