/*

					Oscilloscope AVR

			Copyrights 2008,  Yoshi Hiroshi

*/


//
// PORT DEFINITIONS
//

//
//	START-ADC PORT
//
#define START_ADC_PORT				PORTB
#define START_ADC_DDR				DDRB

/*

	CONTROL PORT

		Controller controls the Timing-Generator via this control port.

			CMND  :  3bit value of command
						4: Set Num of ADCs
						5: Set AS_n
						6-7,0-3: Start ADC
			             6: x1uS, 7: x10uS, 0: x100uS, 1: x1mS, 2: x10mS, 3:x100mS


			PARAM:  2bit parameter
						CMND 0: Set Num of ADCs
							NUM of ADCs 0:1, 1:2, 3:4, 4:8
						CMND 1: Set AS_n
							NUM of AS_n 0:AS_0
										1:AS_0,AS_1
										2:AS_0,AS_1,AS_2,AS_3
										3:AS_0,AS_1,AS_2,AS_3,AS_4,AS_5,AS_6,AS_7
						CMND 3-7: Start ADC
							PERIOD     0: Not Defined  1: 1,  2: 2,  3:5

*/

#define CONTROL_DDR					DDRD
#define CONTROL_PORT				PORTD
#define CONTROL_PIN					PIND
#define CONTROL_PARAM				0x03
#define PARAM_0							0
#define PARAM_1							1
#define CONTROL_COMMAND				0x38
#define COMMAND_0						3
#define COMMAND_1						4
#define COMMAND_2						5
#define CONTROL_DO_COMMAND				0x40

#define PERIOD_TIMER_FAST_CLOCK		_BV(CS11)						// 1/8  = 0.5uS
#define PERIOD_TIMER_SLOW_CLOCK		_BV(CS12)						// 1/256 = 16uS
#define PERIOD_INTERRUPT_MASK		_BV(OCIE1A)



