/*

					Oscilloscope AVR

			Copyrights 2008,  Yoshi Hiroshi

		Control Block - ATmega644P/ATmega324P
*/
void InitBuff();

#define GET_BUFFER_NOWAIT					0
#define GET_BUFFER_WAIT						1

#define NUM_RECIEVE_BUFFERS					8
#define RECIEVE_BUFFER_SIZE					(12 + 1)

#define DATABUFF_SIZE						120
#define NUM_TRANSMIT_BUFFERS				8
#define TRANSMIT_BUFFER_SIZE				(DATABUFF_SIZE + 8)

typedef struct _rxBuffType {
	struct _rxBuffType* next;
	unsigned char buff[RECIEVE_BUFFER_SIZE];
} rxBuffType;

typedef struct _txBuffType {
	struct _txBuffType* next;
	unsigned char buff[TRANSMIT_BUFFER_SIZE];
} txBuffType;

extern char usartRxData;
extern txBuffType* freeTxBuffRoot;
/*
------------------------------------------------------------
		Function Definitions
------------------------------------------------------------
*/

rxBuffType* GetFreeRxBuff(unsigned char wait);
void PutFreeRxBuff(rxBuffType* ptr);
//unsigned char IsFreeRxBuffEmpty();

rxBuffType* GetUsedRxBuff(unsigned char wait);
void PutUsedRxBuff(rxBuffType* ptr);
unsigned char IsUsedRxBuffEmpty();

txBuffType* GetFreeTxBuff(unsigned char wait);
void PutFreeTxBuff(txBuffType* ptr);
//unsigned char IsFreeTxBuffEmpty();

txBuffType* GetUsedTxBuff(unsigned char wait);
void PutUsedTxBuff(txBuffType* ptr);
//unsigned char IsUsedTxBuffEmpty();


