/*

					Oscilloscope AVR

			Copyrights 2008,  Yoshi Hiroshi

		Control Block - ATmega644P/ATmega324P
*/

#include <avr/io.h>
#include "Spi.h"

unsigned char triggerPatternTable[8] = 
{
	0b11111110,
	0b11111101,
	0b11111011,
	0b11110111,
	0b11101111,
	0b11011111,
	0b10111111,
	0b01111111
};

//**********************************************************
//		SPI_Init
//**********************************************************
void SPI_Init()
{
	CH1_SPISS_PORT = CH_SPISS_MASK;
	CH1_SPISS_DDR = CH_SPISS_MASK;
	CH2_SPISS_PORT = CH_SPISS_MASK;
	CH2_SPISS_DDR = CH_SPISS_MASK;
	SPI_PORT |= SPI_DDR_MASK | _BV(SPI_MISO);
	SPI_DDR |= SPI_DDR_MASK;
	SPCR = _BV(SPE) | _BV(MSTR) | _BV(SPR0);
	SPSR = 0;
//	SPSR = _BV(SPI2X);
}

//**********************************************************
//		SPITransmit
//**********************************************************
unsigned char SPITransmit(unsigned char ch, unsigned char unit, unsigned char s, unsigned char flag)
{
	SPISS_SELECT(ch, unit);
	SPDR = s;
	while((SPSR & _BV(SPIF)) == 0);
	if(flag)
	{
//		for(volatile int waitCount = 2; waitCount >= 0; waitCount--);
		SPISS_DESELECT(ch);
	}
	return SPDR;
}

//**********************************************************
//		SPITransmit CH1
//**********************************************************
unsigned char SPITransmit_CH1(unsigned char unit, unsigned char s, unsigned char flag)
{
	SPISS_SELECT_CH1(unit);
	SPDR = s;
	while((SPSR & _BV(SPIF)) == 0);
	if(flag)
	{
//		for(volatile int waitCount = 2; waitCount >= 0; waitCount--);
		SPISS_DESELECT_CH1;
	}
	return SPDR;
}

//**********************************************************
//		SPITransmit CH2
//**********************************************************
unsigned char SPITransmit_CH2(unsigned char unit, unsigned char s, unsigned char flag)
{
	SPISS_SELECT_CH2(unit);
	SPDR = s;
	while((SPSR & _BV(SPIF)) == 0);
	if(flag)
	{
//		for(volatile int waitCount = 2; waitCount >= 0; waitCount--);
		SPISS_DESELECT_CH2;
	}
	return SPDR;
}

