/*

					Oscilloscope AVR

			Copyrights 2008,  Yoshi Hiroshi

		Control Block - ATmega644P/ATmega324P
*/

#define SPI_PORT					PORTB
#define SPI_DDR						DDRB
#define SPI_SS							4
#define SPI_MOSI						5
#define SPI_MISO						6
#define SPI_SCK							7
#define SPI_DDR_MASK				_BV(SPI_SCK)|_BV(SPI_MOSI)|_BV(SPI_SS)

#define CH1_SPISS_PORT				PORTA
#define CH1_SPISS_DDR				DDRA
#define CH2_SPISS_PORT				PORTC
#define CH2_SPISS_DDR				DDRC
#define CH_SPISS_MASK					0xFF

#define SPI_TRANSIMIT_START					0
#define SPI_TRANSIMIT_TERMINATE				1

//====================================================================
unsigned char SPITransmit(unsigned char ch, unsigned char unit, unsigned char s, unsigned char flag);
unsigned char SPITransmit_CH1(unsigned char unit, unsigned char s, unsigned char flag);
unsigned char SPITransmit_CH2(unsigned char unit, unsigned char s, unsigned char flag);
void SPI_Init();


//**********************************************************
//		SPITransmit MACRO
//**********************************************************
#define SPISS_SELECT_CH1(unit)		CH1_SPISS_PORT = triggerPatternTable[unit]
#define SPISS_SELECT_CH2(unit)		CH2_SPISS_PORT = triggerPatternTable[unit]
#define SPISS_DESELECT_CH1			CH1_SPISS_PORT = CH_SPISS_MASK
#define SPISS_DESELECT_CH2			CH2_SPISS_PORT = CH_SPISS_MASK

#define SPISS_SELECT(ch, unit)	if(ch == 1) { SPISS_SELECT_CH1(unit);} else { SPISS_SELECT_CH2(unit);}
#define SPISS_DESELECT(ch)		if(ch == 1) { SPISS_DESELECT_CH1;} else { SPISS_DESELECT_CH2;}

#define WAIT_FOR_SPI_READY(n)			for(volatile int waitCount2 = 3 * (n); waitCount2 >= 0; waitCount2--);
