/*

					Oscilloscope AVR

			Copyrights 2008,  Yoshi Hiroshi

		Control Block - ATmega644P/ATmega324P

*/

#if !defined(__TIMEBASE_SUPPORT_HEADER_INCLUDED__)
#define __TIMEBASE_SUPPORT_HEADER_INCLUDED__


#define TIMEBASE_CODE(x,y)				((x<<4) | y)
#define TIMEBASE_CODE_2uS				TIMEBASE_CODE(2, 6)
#define TIMEBASE_CODE_5uS				TIMEBASE_CODE(5, 6)
#define TIMEBASE_CODE_10uS				TIMEBASE_CODE(1, 7)
#define TIMEBASE_CODE_20uS				TIMEBASE_CODE(2, 7)
#define TIMEBASE_CODE_50uS				TIMEBASE_CODE(5, 7)
#define TIMEBASE_CODE_100uS				TIMEBASE_CODE(1, 8)
#define TIMEBASE_CODE_200uS				TIMEBASE_CODE(2, 8)
#define TIMEBASE_CODE_500uS				TIMEBASE_CODE(5, 8)
#define TIMEBASE_CODE_1mS				TIMEBASE_CODE(1, 9)
#define TIMEBASE_CODE_2mS				TIMEBASE_CODE(2, 9)
#define TIMEBASE_CODE_5mS				TIMEBASE_CODE(5, 9)
#define TIMEBASE_CODE_10mS				TIMEBASE_CODE(1, 10)
#define TIMEBASE_CODE_20mS				TIMEBASE_CODE(2, 10)
#define TIMEBASE_CODE_50mS				TIMEBASE_CODE(5, 10)
#define TIMEBASE_CODE_100mS				TIMEBASE_CODE(1, 11)
#define TIMEBASE_CODE_200mS				TIMEBASE_CODE(2, 11)
#define TIMEBASE_CODE_500mS				TIMEBASE_CODE(5, 11)
#define TIMEBASE_CODE_INVALID			TIMEBASE_CODE(15, 15)

int GetPeriodCodeIndex(unsigned char pc);
long GetAutoTriggerRemain(int pIndex);
long GetAutoTriggerInfinite(int pIndex);
long TimebaseCodeDivision(unsigned char dividendCode, unsigned char divisorCode);
long TimebaseDivision(long dividend, unsigned char divisorCode);


#endif
