/*

					Oscilloscope AVR

			Copyrights 2008,  Yoshi Hiroshi

		Control Block - ATmega644P/ATmega324P
*/

/*
------------------------------------------------------------
		Register Assignment
------------------------------------------------------------
*/
//----------------------------------------------------------
#define UART_DATA_REGISTER				UDR0
#define UART_TRL_STATUS_A				UCSR0A
#define 	UART_DATA_EMPTY_BIT			UDRE0
#define 	UART_2X_SPEED_BIT			U2X0
#define		UART_RECIEVE_COMPLETE_BIT	RXC0
#define UART_TRL_STATUS_B				UCSR0B
#define		UART_RXCMP_INT_ENABLE_BIT		RXCIE0
#define		UART_TXBUFEMPTY_INT_ENABLE_BIT	UDRIE0
#define		UART_RECIEVER_ENABLE_BIT	RXEN0
#define		UART_TRANSMITTER_ENABLE_BIT	TXEN0
#define UART_TRL_STATUS_C				UCSR0C
#define		UART_CHARACTER_SIZE			_BV(UCSZ01) | _BV(UCSZ00)
#define UART_BAUD_RATE_REGISTER			UBRR0
//#define UART_BAUD_RATE_REGISTER_H		UBRR0H
//#define UART_BAUD_RATE_REGISTER_L		UBRR0L
#define TXD0							1
#define UART_TRANSMITTER_PORT_DIRECTION	DDRD |= _BV(TXD0)

//----------------------------------------------------------
// Baud Rate Configulation - 2X Speed/20MHz
#define	USART_BAUDRATE_115200			21
#define	USART_BAUDRATE_230400			10
// Baud Rate Configulation - 1X Speed/20MHz
//#define	USART_BAUDRATE_115200			10
//#define	USART_BAUDRATE_230400			4	// not recomended
#define USART_BAUDRATE					USART_BAUDRATE_230400


/*
------------------------------------------------------------
		Function Definitions
------------------------------------------------------------
*/

void InitUART();
void RecieveDataReady();
void TransmitDataEmpty();

void SendTxBuff(txBuffType* ptr);
